/*
 * see https://www.simtech-ag.ch/education/java/jpf2/resources/lambda/flatmap
 * author: Daniel Schmutz
 * copyright: Simtech AG (https://www.simtech-ag.ch)
 */

package ch.std.jpf2.lambda.flatmap.test;

import static org.junit.Assert.assertTrue;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

import org.junit.Test;

import ch.std.jpf2.lambda.flatmap.Developer;

public class FlatMapTest {

	@Test
	public void flatMap() {
		List<Developer> team = new ArrayList<>();
		Developer polyglot = new Developer("esoteric");
		polyglot.add("clojure");
		polyglot.add("scala");
		polyglot.add("groovy");
		polyglot.add("go");

		Developer busy = new Developer("pragmatic");
		busy.add("java");
		busy.add("javascript");

		team.add(polyglot);
		team.add(busy);

		List<String> teamLanguages = team.stream().map(d -> d.getLanguages()).flatMap(l -> l.stream())
				.collect(Collectors.toList());
		assertTrue(teamLanguages.containsAll(polyglot.getLanguages()));
		assertTrue(teamLanguages.containsAll(busy.getLanguages()));
	}
}