/*
 * see https://www.simtech-ag.ch/education/java/jpf2/resources/lambda/validator
 * author: Daniel Schmutz
 * copyright: Simtech AG (https://www.simtech-ag.ch)
 */

package ch.std.jup8.lambda.validator.lambda;

public class ValidatorDemo {

	public static void main(String[] args) {
		String s = "1234567890";
		try {
			StringValidatorEnum.STRING_32.validate(() -> s);
			StringValidatorEnum.STRING_16.validate(() -> s);
			StringValidatorEnum.STRING_8.validate(() -> s);
		} catch (ValidatorException e) {
			e.printStackTrace();
		}
		// check null 
		try {
			AnyValidator.validate(supplier -> {
				if (supplier.get() == null) {
					throw new ValidatorException();
				}
			}, null);
		} catch (ValidatorException e) {
			e.printStackTrace();
		}
		// check is number 
		try {
			AnyValidator.validate(supplier -> {
				if (supplier.get() == null) {
					throw new ValidatorException();
				}
				Integer.parseInt(supplier.get());
			}, "123");
		} catch (ValidatorException e) {
			e.printStackTrace();
		}

	}
}
